import { AfterContentInit, AfterViewInit, ElementRef, EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { PopoverDirective } from '../../directives/popover.directive';
import { BehaviorSubject } from 'rxjs';
declare type AdvancedSelectOptionValue = any;
interface AdvancedSelectOptionInterface {
    value: AdvancedSelectOptionValue;
    label: string;
    selectedStateLabel?: string;
}
export declare type AdvancedSelectOption = AdvancedSelectOptionInterface | AdvancedSelectOptionValue;
export declare class AdvancedOptionComponent implements AfterContentInit, OnDestroy {
    parent: AdvancedSelectComponent;
    elementRef: ElementRef<HTMLElement>;
    index: any;
    class: string;
    valueValue: AdvancedSelectOption;
    set value(value: any);
    get value(): any;
    highlighted: any;
    selected: any;
    private ngDestroy$;
    constructor(parent: AdvancedSelectComponent, elementRef: ElementRef<HTMLElement>);
    get label(): string;
    ngAfterContentInit(): void;
    updateState(): void;
    ngOnDestroy(): void;
}
export declare class AdvancedSelectComponent implements AfterViewInit, OnDestroy, ControlValueAccessor {
    elementRef: ElementRef<HTMLElement>;
    private ngDestroy$;
    advancedOptionComponents: AdvancedOptionComponent[];
    highlightedOptionIndex$: BehaviorSubject<number>;
    optionsComponentList: QueryList<AdvancedOptionComponent>;
    set multiple(multiple: boolean);
    get multiple(): boolean;
    queryEnabled: boolean;
    arrow: boolean;
    set query(query: string);
    get query(): string;
    set value(value: AdvancedSelectOption | AdvancedSelectOption[]);
    get value(): AdvancedSelectOption | AdvancedSelectOption[];
    get valueAsArray(): AdvancedSelectOption[];
    get valueAsOne(): AdvancedSelectOption;
    constructor(elementRef: ElementRef<HTMLElement>);
    bootstrap: boolean;
    popover: PopoverDirective;
    inputElement: ElementRef<HTMLInputElement>;
    queryValue: string;
    queryChange: EventEmitter<string>;
    options: AdvancedSelectOption[];
    uniqueValues: boolean;
    multipleValue: boolean;
    valueValue: AdvancedSelectOption | AdvancedSelectOption[];
    valueChange: EventEmitter<any>;
    selectValue(option: AdvancedSelectOption): boolean;
    deselectValue(value: AdvancedSelectOption): void;
    updateModel(): void;
    getSelectedLabel(option: AdvancedSelectOption): string;
    onChange: (value: any) => any;
    ngAfterViewInit(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    writeValue(value: AdvancedSelectOptionValue | AdvancedSelectOptionValue[]): void;
    ngOnDestroy(): void;
    enter(): void;
    backspace(): boolean;
    moveIndex(amount: any): void;
    onFocus(): void;
    eventHandle(event: Event): void;
    onArrowClick(): void;
}
export {};
