import { EventEmitter, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BehaviorSubject, OperatorFunction } from 'rxjs';
import { ImageInputValue } from '../image-input/image-input.component';
export declare class GalleryImageValue extends ImageInputValue {
    sort: number;
}
export declare class ImageGalleryComponent implements OnDestroy, ControlValueAccessor {
    disabled: boolean;
    bootstrap: boolean;
    valueChange: BehaviorSubject<GalleryImageValue[]>;
    delete: EventEmitter<{
        deleted: GalleryImageValue;
        index: number;
        images: GalleryImageValue[];
    }>;
    imageInputModifier: OperatorFunction<GalleryImageValue, any>;
    randomId: string;
    index: number;
    originalValue: GalleryImageValue[];
    selected: GalleryImageValue;
    htmlElementObserver: MutationObserver;
    dir: string;
    set value(value: GalleryImageValue[]);
    get value(): GalleryImageValue[];
    constructor();
    onChangeFn: (x: GalleryImageValue[]) => any;
    ngOnDestroy(): void;
    registerOnChange(fn: (x: GalleryImageValue[]) => any): void;
    registerOnTouched(fn: any): void;
    writeValue(obj: GalleryImageValue[]): void;
    setDisabledState(isDisabled: boolean): void;
    newImage($event: ImageInputValue): void;
    deleteImage(index: any): void;
    swapImages(aIndex: any, bIndex: any): void;
}
