import { ElementRef, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BehaviorSubject, OperatorFunction } from 'rxjs';
export declare class ImageInputValue {
    id: string;
    src: string | ArrayBuffer;
    blob?: Blob | File;
    value?: any;
}
export declare class ImageInputComponent implements OnInit, ControlValueAccessor {
    elementRef: ElementRef;
    randomId: string;
    bootstrap: boolean;
    draggedOver: boolean;
    get hasImage(): boolean;
    disabled: boolean;
    interactive: boolean;
    bgImage: string;
    originalValue: ImageInputValue;
    set placeholderValue(value: ImageInputValue);
    set value(value: ImageInputValue);
    get value(): ImageInputValue;
    valueChange: BehaviorSubject<ImageInputValue>;
    modifier: OperatorFunction<ImageInputValue, any>;
    constructor(elementRef: ElementRef);
    onChangeFn: (x: ImageInputValue) => any;
    ngOnInit(): void;
    registerOnChange(fn: (x: ImageInputValue) => any): void;
    registerOnTouched(fn: any): void;
    writeValue(obj: ImageInputValue): void;
    setDisabledState(isDisabled: boolean): void;
    fileChange($event: Event | DragEvent): void;
}
