import { AfterContentInit, ElementRef, EventEmitter, OnDestroy, TemplateRef } from '@angular/core';
import { Popover, PopoverHorizontalPlacement, PopoverService, PopoverVerticalPlacement } from '../services/popover.service';
declare type PopoverHooks = 'hover' | 'click' | '' | null;
export declare class PopoverDirective implements AfterContentInit, OnDestroy {
    private popoverService;
    private elementRef;
    private ngDestroy$;
    popoverReady: EventEmitter<any>;
    popover: Popover;
    private popoverContentValue$;
    set popoverContent(content: string | HTMLElement | HTMLElement[] | TemplateRef<any>);
    popoverOnHook: PopoverHooks;
    set popoverOn(hook: any);
    popoverPlacementValue: {
        horizontal: PopoverHorizontalPlacement;
        vertical: PopoverVerticalPlacement;
    };
    set popoverPlacement(popoverPlacementValue: any);
    popoverClassValue: string;
    set popoverClass(customClass: any);
    popoverArrowValue: boolean;
    set popoverArrow(customArrow: boolean);
    popoverMatchWidthValue: boolean | 'min-width';
    set popoverMatchWidth(matchWidth: boolean | 'min-width');
    popoverMaxWindowHeightValue: boolean;
    set popoverMatchHeight(matchHeight: boolean);
    show(): void;
    hide(): void;
    forceShow(bool?: boolean): void;
    constructor(popoverService: PopoverService, elementRef: ElementRef<HTMLElement>);
    ngAfterContentInit(): Promise<void>;
    private updateHook;
    private activateOnHover;
    private activateOnClick;
    ngOnDestroy(): void;
}
export {};
