import { ActivatedRoute, ActivatedRouteSnapshot, Route, Router } from '@angular/router';
import { BehaviorSubject } from 'rxjs';
export interface Breadcrumb {
    id: string;
    label?: string;
    url: string;
    index: number;
}
export interface BreadcrumbRoute extends Route {
    breadcrumb?: string;
    breadcrumbPatched?: string;
    id?: string;
    children?: BreadcrumbRoute[];
}
export declare type BreadcrumbRoutes = BreadcrumbRoute[];
export declare class BreadcrumbsService {
    private activatedRoute;
    private router;
    breadcrumbs$: BehaviorSubject<Breadcrumb[]>;
    private refresh$;
    firstRun: boolean;
    private previousUrl;
    constructor(activatedRoute: ActivatedRoute, router: Router);
    digBreadcrumbs(route: ActivatedRouteSnapshot, patched?: boolean, breadcrumbs?: Breadcrumb[]): any;
    updateBreadcrumb(route: ActivatedRoute | ActivatedRouteSnapshot, label: any): void;
}
